Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.nwoods.jgo.instruments
Class IndicatorNeedle

    java.lang.Object
      com.nwoods.jgo.JGoObject
          com.nwoods.jgo.JGoDrawable
              com.nwoods.jgo.instruments.AbstractIndicator
                  com.nwoods.jgo.instruments.IndicatorNeedle

All Implemented Interfaces:
  JGoActionObject, JGoXMLSaveRestore, java.io.Serializable

public class IndicatorNeedle
extends AbstractIndicator

An indicator that displays the current value by drawing a straight line from a PivotPoint.

See Also:
  Serialized Form

Field Summary
`static int` | `ChangedConstantLength` This is a JGoObject update subhint.
`static int` | `ChangedLength` This is a JGoObject update subhint.
`static int` | `ChangedPivotPoint` This is a JGoObject update subhint.
`static int` | `ChangedStyle` This is a JGoObject update subhint.
`static int` | `ChangedThickness` This is a JGoObject update subhint.
`static int` | `StyleBar` The IndicatorNeedle appears as a rectangle
`static int` | `StyleKite` The IndicatorNeedle appears as a kite
`static int` | `StyleLine` The IndicatorNeedle appears as a line between its pivot and end point

Fields inherited from class com.nwoods.jgo.instruments.AbstractIndicator
`ChangedActionEnabled, ChangedQuantBase, ChangedQuantized, ChangedQuantUnit, ChangedScale, ChangedValue`

Fields inherited from class com.nwoods.jgo.JGoObject
`Bottom, BottomCenter, BottomLeft, BottomMiddle, BottomRight, Center, CenterLeft, CenterRight, Changed4ResizeHandles, ChangedAutoRescale, ChangedBrush, ChangedDraggable, ChangedDragsNode, ChangedGeometry, ChangedGrabChildSelection, ChangedInitializing, ChangedPen, ChangedResizable, ChangedSelectable, ChangedUpdatePartner, ChangedVisible, ChangedZOrder, LastChangedHint, Left, LeftCenter, NoHandle, NoSpot, NumReservedHandles, RepaintAll, Right, RightCenter, SideLeft, SideRight, Top, TopCenter, TopLeft, TopMiddle, TopRight`

Constructor Summary
`IndicatorNeedle()` This constructor creates an IndicatorNeedle with all default properties.

Method Summary
`void` | `changeValue(JGoDocumentChangedEdit e, boolean undo)` Handle undo and redo changes.
`protected void` | `computePath(java.awt.geom.GeneralPath path)` Initializes a GeneralPath used to paint this AbstractIndicator.
`void` | `copyNewValueForRedo(JGoDocumentChangedEdit e)` This method is called when a JGoDocumentChangedEdit is created for a JGoDocumentEvent.CHANGED event, when a JGoObject has been changed.
`JGoObject` | `copyObject(JGoCopyEnvironment env)` Copy the field values and the internal data structures to avoid sharing references
`protected void` | `geometryChange(java.awt.Rectangle old)` Update the PivotPoint proportionately.
`float` | `getLength()` Gets whether the length to which the IndicatorNeedle will be drawn, if IndicatorNeedle.ConstantLength is true.
`java.awt.Point` | `getPivotPoint()` Gets a fixed point which the needle will rotate around.
`int` | `getStyle()` Gets or sets the style used to draw the IndicatorNeedle.
`float` | `getThickness()` Used when drawing needles with the Kite or Bar style.
`double` | `getValueForPoint(java.awt.Point dc)` This method is called by onActionAdjusted and onAction to get the proposed new value for the given mouse point.
`boolean` | `isConstantLength()` Gets whether the needle will maintain a set length.
`boolean` | `isPointInObj(java.awt.Point p)` Determine if a given point is inside and on this object.
`void` | `setConstantLength(boolean value)` Sets whether the needle will maintain a set length.
`void` | `setLength(float value)` Sets whether the length to which the IndicatorNeedle will be drawn, if IndicatorNeedle.ConstantLength is true.
`void` | `setPivotPoint(java.awt.Point value)` Sets a fixed point which the needle will rotate around.
`void` | `setStyle(int value)` Sets the style used to draw the IndicatorNeedle.
`void` | `setThickness(float value)` Used when drawing needles with the Kite or Bar style.
`DomNode` | `SVGReadObject(DomDoc svgDoc, JGoDocument jGoDoc, DomElement svgElement, DomElement jGoChildElement)` Read this object in from a DomDoc representing a Scalable Vector Graphics (SVG) XML document.
`void` | `SVGWriteObject(DomDoc svgDoc, DomElement jGoElementGroup)` Write this object out to a DomDoc representing a Scalable Vector Graphics (SVG) XML document.

Methods inherited from class com.nwoods.jgo.instruments.AbstractIndicator
`doUncapturedMouseMove, expandRectByPenWidth, generateSVGOutput, getPartner, getPath, getQuantizeBase, getQuantizeUnit, getScale, getValue, isActionActivated, isActionEnabled, isQuantized, makePath, onAction, onActionAdjusted, onActionCancelled, paint, quantizeValue, resetPath, setActionActivated, setActionEnabled, setPartner, setQuantizeBase, setQuantized, setQuantizeUnit, setScale, setValue, SVGUpdateReference, validValue`

Methods inherited from class com.nwoods.jgo.JGoDrawable
`draw3DRect, draw3DRect, drawEllipse, drawEllipse, drawEllipse, drawLine, drawLine, drawPath, drawPolygon, drawPolygon, drawRect, drawRect, drawRect, drawRoundRect, drawRoundRect, getBrush, getNearestIntersectionPoint, getPen, setBrush, setPen, SVGAddPathArgs, SVGReadAttributes, SVGWriteAttributes`

Methods inherited from class com.nwoods.jgo.JGoObject
`canView, computeBoundingRect, computeMove, computeResize, copy, copyObjectDelayed, copyOldValueForUndo, copyRect, doMouseClick, doMouseDblClick, findCommonParent, foredate, gainedSelection, geometryChangeChild, getBoundingRect, getDocument, getDraggingObject, getFlags, getHeight, getLayer, getLeft, getLocation, getLocation, getParent, getParentJGoNode, getParentNode, getRectangleSpotLocation, getSize, getSize, getSpotLocation, getSpotLocation, getToolTipText, getTop, getTopLeft, getTopLeft, getTopLevelObject, getView, getWidth, growRect, handleMove, handleResize, hideSelectionHandles, is4ResizeHandles, isAutoRescale, isBoundingRectInvalid, isChildOf, isDraggable, isDragsNode, isInitializing, isResizable, isSelectable, isSkipsUndoManager, isSuspendChildUpdates, isSuspendUpdates, isTopLevel, isUpdatePartner, isVisible, lostSelection, ownerChange, partnerUpdate, pick, redirectSelection, remove, set4ResizeHandles, setAutoRescale, setBoundingRect, setBoundingRect, setBoundingRect, setBoundingRectForce, setBoundingRectForce, setBoundingRectInvalid, setBoundsRect, setDraggable, setDragsNode, setFlags, setHeight, setInitializing, setLeft, setLocation, setLocation, setLocationOffset, setLocationOffset, setParent, setRectangleSpotLocation, setResizable, setSelectable, setSize, setSize, setSizeKeepingLocation, setSkipsUndoManager, setSpotLocation, setSpotLocation, setSpotLocation, setSpotLocationOffset, setSuspendChildUpdates, setSuspendUpdates, setTop, setTopLeft, setTopLeft, setUpdatePartner, setVisible, setWidth, showSelectionHandles, spotOpposite, update, update`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### StyleLine

    public static final int StyleLine

  The IndicatorNeedle appears as a line between its pivot and end point

  See Also:
    Constant Field Values

### StyleKite

    public static final int StyleKite

  The IndicatorNeedle appears as a kite

  See Also:
    Constant Field Values

### StyleBar

    public static final int StyleBar

  The IndicatorNeedle appears as a rectangle

  See Also:
    Constant Field Values

### ChangedPivotPoint

    public static final int ChangedPivotPoint

  This is a JGoObject update subhint.

  See Also:
    Constant Field Values

### ChangedConstantLength

    public static final int ChangedConstantLength

  This is a JGoObject update subhint.

  See Also:
    Constant Field Values

### ChangedLength

    public static final int ChangedLength

  This is a JGoObject update subhint.

  See Also:
    Constant Field Values

### ChangedThickness

    public static final int ChangedThickness

  This is a JGoObject update subhint.

  See Also:
    Constant Field Values

### ChangedStyle

    public static final int ChangedStyle

  This is a JGoObject update subhint.

  See Also:
    Constant Field Values

Constructor Detail

### IndicatorNeedle

    public IndicatorNeedle()

  This constructor creates an IndicatorNeedle with all default properties.

Method Detail

### copyObject

    public JGoObject copyObject(JGoCopyEnvironment env)

  Copy the field values and the internal data structures to avoid sharing references

  Overrides:
    `copyObject` in class `AbstractIndicator`
  Parameters:
    `env` - the environment for the copy operation - keeps track of copied objects.
  Returns:
    the new IndicatorNeedle

### getPivotPoint

    public java.awt.Point getPivotPoint()

  Gets a fixed point which the needle will rotate around.

  When you change the bounding rectangle for this object, you will also need to update this property.

### setPivotPoint

    public void setPivotPoint(java.awt.Point value)

  Sets a fixed point which the needle will rotate around.

  When you change the bounding rectangle for this object, you will also need to update this property.

  Parameters:
    `value` - the value must be a point within the BoundingRect of this IndicatorNeedle.

### isConstantLength

    public boolean isConstantLength()

  Gets whether the needle will maintain a set length.

  If ConstantLength is false, the needle will be drawn the length of the line between PivotPoint and the Point returned by GraduatedScale.getPointForValue. If it is true, the needle will be drawn according to the Length property, along the line connecting PivotPoint and the Point returned by GraduatedScale.getPointForValue.

### setConstantLength

    public void setConstantLength(boolean value)

  Sets whether the needle will maintain a set length.

  If ConstantLength is false, the needle will be drawn the length of the line between PivotPoint and the Point returned by GraduatedScale.getPointForValue. If it is true, the needle will be drawn according to the Length property, along the line connecting PivotPoint and the Point returned by GraduatedScale.getPointForValue.

### getLength

    public float getLength()

  Gets whether the length to which the IndicatorNeedle will be drawn, if IndicatorNeedle.ConstantLength is true.

### setLength

    public void setLength(float value)

  Sets whether the length to which the IndicatorNeedle will be drawn, if IndicatorNeedle.ConstantLength is true.

  Parameters:
    `value` - must a positive distance in document coordinates

### getThickness

    public float getThickness()

  Used when drawing needles with the Kite or Bar style.

### setThickness

    public void setThickness(float value)

  Used when drawing needles with the Kite or Bar style.

  Parameters:
    `value` - a positive distance in document coordinates

### getStyle

    public int getStyle()

  Gets or sets the style used to draw the IndicatorNeedle.

### setStyle

    public void setStyle(int value)

  Sets the style used to draw the IndicatorNeedle.

  Parameters:
    `value` - one of: StyleLine, StyleKite, StyleBar

### geometryChange

    protected void geometryChange(java.awt.Rectangle old)

  Update the PivotPoint proportionately.

  Overrides:
    `geometryChange` in class `AbstractIndicator`
  Parameters:
    `old` -

### computePath

    protected void computePath(java.awt.geom.GeneralPath path)

  Initializes a GeneralPath used to paint this AbstractIndicator.

  The default method for painting Indicators relies on this function for a definition of the shape. However, AbstractIndicator.Paint can be overriden to not require this function.

  Overrides:
    `computePath` in class `AbstractIndicator`
  Parameters:
    `path` - a GeneralPath that is modified

### isPointInObj

    public boolean isPointInObj(java.awt.Point p)

  Determine if a given point is inside and on this object.

  Overrides:
    `isPointInObj` in class `JGoObject`
  Parameters:
    `p` -
  Returns:
    true if the point is contained by the indicator's path, or near the line if it is just a line.

### getValueForPoint

    public double getValueForPoint(java.awt.Point dc)

  Description copied from class: `AbstractIndicator`
  This method is called by onActionAdjusted and onAction to get the proposed new value for the given mouse point.

  Overrides:
    `getValueForPoint` in class `AbstractIndicator`
  Parameters:
    `dc` - a Point in document coordinates
  Returns:
    the new value, a double

### copyNewValueForRedo

    public void copyNewValueForRedo(JGoDocumentChangedEdit e)

  Description copied from class: `JGoObject`
  This method is called when a JGoDocumentChangedEdit is created for a JGoDocumentEvent.CHANGED event, when a JGoObject has been changed. In order for the JGoDocumentChangedEdit to be able to perform a redo, it needs to remember the new property value or state. However, the JGoObject.update method does not provide such a new value. The value must be taken from this object and copied into the JGoDocumentChangedEdit by calling setNewValue and/or setNewValueInt.

  Just as the previous/old value/state information is stored as one or both of an integer and an Object, the new value/state information may be stored as either or both of an integer or an Object.

  The responsibility for copying rests with the document event listener rather than the code calling JGoObject.update for efficiency when there is no undo/redo manager.

  Overrides:
    `copyNewValueForRedo` in class `AbstractIndicator`

### changeValue

    public void changeValue(JGoDocumentChangedEdit e,
                            boolean undo)

  Handle undo and redo changes.

  Overrides:
    `changeValue` in class `AbstractIndicator`
  Parameters:
    `e` -
    `undo` -

### SVGWriteObject

    public void SVGWriteObject(DomDoc svgDoc,
                               DomElement jGoElementGroup)

  Description copied from interface: `JGoXMLSaveRestore`
  Write this object out to a DomDoc representing a Scalable Vector Graphics (SVG) XML document.

  This method will be called by com.nwoods.jgo.svg.DefaultDocument.SVGWriteDoc() for every JGoObject contained within a JGoDocument. The following example uses a JGoRectangle to illustrate the format of a generated SVG JGoObject:

  <g>
  <JGoClass class="com.nwoods.jgo.JGoRectangle"\>
  <rect height="75" style="stroke:black;stroke-width:1;fill:rgb(255,0,0);" width="75" x="65" y="71"/>
  <JGoClass class="com.nwoods.jgo.JGoDrawable" drawablebrush="jgoid1" drawablepen="jgoid2" embeddedpenbrush="false"/>
  <JGoClass class="com.nwoods.jgo.JGoObject" obj_flags="1054"/>
  </g>

  Note that the entire JGoObject is enclosed in a group (<g>). Each subclass of the JGoObject is described by a <JGoClass> element, starting with the most specific class and moving to the more general. Each <JGoClass> element has a "class" attribute which defines the class name. Each <JGoClass> element may also have several other attributes which uniquely describe that state of that class. Following the <JGoClass> element, each class may also genereate any other elements that are required, including representations of contained objects and standard SVG elements such as the <rect> element shown in the above example. The generation of SVG elements in the output makes it possible for the output to be read by SVG viewers and other SVG aware applications. The information contained in the <JGoClass> elements allows us to accurately save and restore all the information in a particular JGoObject subclass.

  If this class contains a reference to another object, call DomDoc.registerReferencingNode() to register that reference. This will cause the element representing the referenced object to be identified with a unique id attribute, and cause the element representing the referring object to have a user defined attribute containing a reference to that id. See DomDoc.registerReferencingNode() for more information.

  Typically, an implementation of this method will generate a <JGoClass> element using the DomDoc.createJGoClassElement() method, adding whatever attributes are necessary to describe the class. It will then call its superclass so that the superclass can add its own <JGoClass> element and other information to jGoElementGroup within the DomDoc.

  Refer to com.nwoods.jgo.examples.flower.ActivityNode.SVGWriteObject() and com.nwoods.jgo.examples.SimpleNode.SVGWriteObject() for examples using this method.

  Refer to the file com.nwoods.jgo.svg\xsvg.dtd for a formal description of JGo extensions to the SVG document type.

  Specified by:
    `SVGWriteObject` in interface `JGoXMLSaveRestore`
  Overrides:
    `SVGWriteObject` in class `AbstractIndicator`

### SVGReadObject

    public DomNode SVGReadObject(DomDoc svgDoc,
                                 JGoDocument jGoDoc,
                                 DomElement svgElement,
                                 DomElement jGoChildElement)

  Description copied from interface: `JGoXMLSaveRestore`
  Read this object in from a DomDoc representing a Scalable Vector Graphics (SVG) XML document.

  This method will be called by com.nwoods.jgo.svg.DefaultDocument.SVGReadDoc() for every <JGoClass> element encountered in a DomDoc. First, an object of the type specified by the class attribute will be created and then the SVGReadObject() method will be called on that newly created object. Refer to SVGWriteObject() for a description of the expected format of the SVG document.

  This method may also be called by com.nwoods.jgo.svg.DefaultDocument.SVGReadDoc() when reading any SVG document, including those not generated by JGo and therefore not containing any <JGoClass> elements. In such cases, the DefaultDocument.SVGReadElement() method may be subclassed to examine the SVG element and cause the appropriate JGoObject to be created to represent that element and call SVGReadObject() on that newly created object. By default, standard JGoObjects such as JGoRectangles, JGoStrokes, etc will be created to represent these objects.

  If this class contains a reference to another object, call DomDoc.registerReferencingObject() to register that reference. This will cause the JGoObject.SVGUpdateReference() to be called on the referencing object after all the objects have been created, passing in the object befing referenced. See DomDoc.registerReferencingObject() for more information.

  Typically, an implementation of this method starts by verifying that the element being read is a <JGoClass> element (which will be true if jGoChildElement is not null). This will always be true unless you have subclassed the DefaultDocument.SVGReadElement() method as described above. It will then read the expected attributes of the <JGoClass> element (as written by SVGReadObject()), call SVGReadObject() on its superclass, and finally return the next element by calling svgElement.getNextSibling().

  Refer to com.nwoods.jgo.examples.flower.ActivityNode.SVGReadObject() and com.nwoods.jgo.examples.SimpleNode.SVGReadObject() for examples using this method.

  Specified by:
    `SVGReadObject` in interface `JGoXMLSaveRestore`
  Overrides:
    `SVGReadObject` in class `AbstractIndicator`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD